#include<bits/stdc++.h>
using namespace std;
#define ll long long
int a[300000],b[300000];
ll const mod=998244353;


ll brzos(ll x,ll y){
    if(y==0) return 1;
    ll p =brzos(x,y/2);
    if(y&1) return (((p*p)%mod)*x)%mod;
    else return (p*p)%mod;
}



int main(){
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n,m;
    ll c;
    cin >> n >> m;

    for(int i=1;i<=m;i++){
        cin >> b[i];
    }
    cin >> c;
    for(int i=1;i<=n;i++){
        a[i]=i;
    }

    for(int i=0;i<=n-m;i++){
        for(int j=1;j<=m;j++) a[i + b[j]] = a[i + j];
    }
    ll resenje=0;

    for(int i=1;i<=n;i++){
        resenje += (ll)(brzos(c,(ll)i)*(ll)a[i])%mod;
    }


    cout << resenje;
    return 0;
}